#ifndef PACKAGE__PROG__PRJLIBS__CASE_H
#define PACKAGE__PROG__PRJLIBS__CASE_H

#include "warn.h"

#define CASE_IS_UPPER(ch) \
  ('A'<=WARN_CAST(unsigned char, ch) && (unsigned char)(ch)<='Z')
#define CASE_IS_LOWER(ch) \
  ('a'<=WARN_CAST(unsigned char, ch) && (unsigned char)(ch)<='z')
#define CASE_TO_UPPER(ch) \
  (CASE_IS_LOWER(ch)? (unsigned char)(ch)-'a'+'A': (unsigned char)(ch))
#define CASE_TO_LOWER(ch) \
  (CASE_IS_UPPER(ch)? (unsigned char)(ch)-'A'+'a': (unsigned char)(ch))

#endif
