#include "prjlibs-c/standards.h"
#include <skalibs/stddjb.h>
#include "prjlibs-c/constants.h"
#include "prjlibs-c/diewarn.h"
#include "types.h"

void imap_respond(ccp r0, ccp r1, ccp r2, ccp r3, ccp r4, ccp r5) {
  imap_mustwrite(r0);
  do {
    if (r1==NULLP) break; imap_mustwrite(r1);
    if (r2==NULLP) break; imap_mustwrite(r2);
    if (r3==NULLP) break; imap_mustwrite(r3);
    if (r4==NULLP) break; imap_mustwrite(r4);
    if (r5==NULLP) break; imap_mustwrite(r5);
  } while (0);
  imap_mustwrite("\r\n");
  if (buffer_flush(buffer_1)<0) DIE1(write, "network");
}
