#include "prjlibs-c/types.h"
#include "prjlibs-c/diewarn.h"

#define must_alloc(vec, n) \
  ((void)(VEC_ALLOC(char, (vec), (n), 0)==0 || (DIE0(alloc), 0)))
#define must_n(vec, data, n) \
  ((void)(VEC_PUSHN(char, (vec), (data), (n))==0 || (DIE0(alloc), 0)))
#define must_a(vec, data, n) \
  ((void)(VEC_PUSHA(char, (vec), (data), (n))==0 || (DIE0(alloc), 0)))
#define must_s(vec, data, n) \
  ((void)(VEC_PUSHS(      (vec), (data), (n))==0 || (DIE0(alloc), 0)))
#define must_at(vec, data) \
  ((void)(VEC_PUSHA(char, (vec), (data), 0)!=0 \
          ? VEC_POP1(char, (vec)) \
          : (DIE0(alloc), (void*)0)))
#define must_0(vec) must_at((vec), "")
#define must_1(vec, elt) \
  ((void)(VEC_PUSH1(char, (vec), (elt)      )==0 || (DIE0(alloc), 0)))

/*
#define MUST_SA1(op, sa, arg1) \
  ((void)(stralloc_##op((sa), (arg1))!=0 || (DIE0(alloc), 0)))
#define MUST_SA2(op, sa, arg1, arg2) \
  ((void)(stralloc_##op((sa), (arg1), (arg2))!=0 || (DIE0(alloc), 0)))
#define must_ready(sa, len) MUST_SA1(ready, (sa), (len))
#define must_append(sa, c) MUST_SA1(append, (sa), (c))
#define must_cats(sa, s) MUST_SA1(cats, (sa), (s))
#define must_copys(sa, s) MUST_SA1(copys, (sa), (s))
#define must_copyb(sa, s, len) MUST_SA2(copyb, (sa), (s), (len))
#define must_catb(sa, s, len) MUST_SA2(catb, (sa), (s), (len))

#define MUST_COPY(sa0, sa1) must_copyb((sa0), (sa1)->s, (sa1)->len)
#define MUST_CAT( sa0, sa1) must_catb ((sa0), (sa1)->s, (sa1)->len)
#define MUST_COPYS(sa, data) \
  (WARN_ARR(char const, data), must_copyb((sa), (data), sizeof (data)-1))
#define MUST_CATS( sa, data) \
  (WARN_ARR(char const, data), must_catb((sa), (data), sizeof (data)-1))
#define MUST_CATS0(sa, data) \
  (WARN_ARR(char const, data), must_catb((sa), (data), sizeof (data)))
#define MUST_CATST(sa, data) (MUST_CATS0((sa), (data)), --(sa)->len)
*/

extern type_status must_fill(buffer* buf, char const* src);
#define MUST_FILL_0() must_fill(buffer_0, src_stdin)
/*
#define MUST_GETC(buf, src, ch) do { \
  if (buffer_GETC((buf), (ch))<0) DIE1(read, src); \
} while (0)
*/
