#include "prjlibs-c/standards.h"
#include <unistd.h>
#include <fcntl.h>

#include <skalibs/stddjb.h>
#include "prjlibs-c/check_close.h"
#include "dirsync.h"

type_status dirsync(ccp path) {
  type_fd fd=open2(path, O_RDONLY);
  if (fd<0)               return -1;
  if (fsync(fd)!=0)       return -1;
  if (check_close(fd)!=0) return -1;
  return 0;
}
