
void imap_list(type_bool flag_subscribed_only) {
  str arg=VEC_0(char);
  mailbox_t const* mb;
  type_bool flag_ref_empty;
  update_mb_list();
  if (read_sp_astring(&arg, 0)!=0) { VEC_FREE(char, &arg); REJECT(); }
  flag_ref_empty=(l(&arg)==0);
  if (read_sp_astring(&arg, 1)!=0) { VEC_FREE(char, &arg); REJECT(); }
  END_ARGS();
  if (l(&arg)==0)
    RESPOND_NOTAG_2(cmd->name, " (\\Noselect) NIL \"\"");
  else if (flag_ref_empty && byte_chr(s(&arg), l(&arg), '\0')==l(&arg)) {
    type_len i=byte_in(s(&arg), l(&arg), "*%", 2);
    if (i==l(&arg)) {
      mb=find_mailbox(&arg);
      if (mb!=NULLP)
        RESPOND_NOTAG_5(cmd->name, " (\\Noinferiors",
                        (mb->flag_exists? "": " \\Noselect"),
                        ") NIL ", mb->name);
      /* modified UTF-7 & */ 
    } else {
      /* multiple wildcards */ 
      type_len j=l(&arg)-i-1;
      for (mb=mb_list; mb!=NULLP; mb=mb->next) {
        if (flag_subscribed_only && !mb->flag_subscribed) continue;
        if (mb->name_len<l(&arg)-1) continue;
        if (byte_diff(mb->name, i, s(&arg))) continue;
        if (byte_diff(mb->name+mb->name_len-j, j, s(&arg)+i+1)) continue;
        RESPOND_NOTAG_5(cmd->name, " (\\Noinferiors",
                        (mb->flag_exists? "": " \\Noselect"),
                        ") NIL ", mb->name);
      }
    }
  }
  RESPOND_OK_0();
  VEC_FREE(char, &arg);
}
