#include "prjlibs-c/standards.h"
#include <skalibs/stddjb.h>
#include "prjlibs-c/constants.h"
#include "prjlibs-c/diewarn.h"
#include "respond.h"

typedef char const* ccp;

void mustwrite(ccp text) {
  if (buffer_puts(buffer_1, text)<0) DIE1(write, "network");
}

void respond(ccp r0, ccp r1, ccp r2, ccp r3, ccp r4, ccp r5) {
  mustwrite(r0);
  do {
    if (r1==NULLP) break;
    mustwrite(r1);
    if (r2==NULLP) break;
    mustwrite(r2);
    if (r3==NULLP) break;
    mustwrite(r3);
    if (r4==NULLP) break;
    mustwrite(r4);
    if (r5==NULLP) break;
    mustwrite(r5);
  } while (0);
  mustwrite("\r\n");
  if (buffer_flush(buffer_1)==0) DIE1(write, "network");
}
