#include "prjlibs-c/standards.h"
#include <stddef.h>

#include "prjlibs-c/vec.h"
#include "types.h"
#include "uil.h"

type_uid uil_nth(type_uil const* uil, size_t n) {
  size_t i;
  size_t const          len =VEC_LEN (type_uid, uil);
  type_uid const* const elts=VEC_ELTS(type_uid, uil);
  for (i=0; i!=len; i+=2) {
    type_uid const range=elts[i+1]-elts[i];
    if (n<range) return elts[i]+n+1;
    n-=range;
  }
  return 0;
}
